' Internet Explorer Bookmark Importer/Exporter
' Please excuse the poor coding as I am not terribly familiar with VB
' Please excuse the poor commenting as I am not a very good commentator
' Class created:    27-Nov-2005
' Last updated:     30-Nov-2005
' - Team Tools
Public Class InternetExplorer
    Inherits Browser

    'Private favoritesPath As String

    ' GetFileName Function shamelessly "borrowed" from FreeVBCode.com
    ' Author: Maria Rapini, marapin@yahoo.com  
    Private Function getFileName(ByVal flname As String) As String
        'Get the filename without the path or extension.
        'Input Values:
        '   flname - path and filename of file.
        'Return Value:
        '   GetFileName - name of file without the extension.
        Dim posn As Integer, i As Integer
        Dim fName As String
        posn = 0
        'find the position of the last "\" character in filename
        For i = 1 To Len(flname)
            If (Mid(flname, i, 1) = "\") Then posn = i
        Next i
        'get filename without path
        fName = Right(flname, Len(flname) - posn)
        'get filename without extension
        posn = InStr(fName, ".")
        If posn <> 0 Then
            fName = Left(fName, posn - 1)
        End If
        getFileName = fName
    End Function
    Private Function getFileNameExt(ByVal fileName As String) As String
        Dim intPos As Integer
        Dim intPosSave As Integer
        If InStr(fileName, ".") = 0 Then
            Return ("")
            Exit Function
        End If
        intPos = 1
        Do
            intPos = InStr(intPos, fileName, ".")
            If intPos = 0 Then
                Exit Do
            Else
                intPos = intPos + 1
                intPosSave = intPos - 1
            End If
        Loop
        Return (Trim$(Mid$(fileName, intPosSave + 1)))
    End Function


    Private Function createFolderEntry(ByVal folderName As String) As FolderEntry
        ' Utility function used by parseFolder to create a new folder entry
        Dim newFolderEntry As New FolderEntry
        newFolderEntry.Name = folderName
        Return (newFolderEntry)
    End Function
    Private Function createBookmarkEntry(ByVal bookmarkName As String, ByVal bookmarkDescription As String, ByVal bookmarkURL As String) As BookmarkEntry
        ' Utility function used by parseFolder to create a new bookmark entry
        Dim newBookmarkEntry As New BookmarkEntry
        newBookmarkEntry.Name = bookmarkName
        newBookmarkEntry.Description = bookmarkDescription
        newBookmarkEntry.URL = bookmarkURL
        Return (newBookmarkEntry)
    End Function

    Private Sub parseFolder(ByRef currentFolderEntry As FolderEntry, ByVal currentDirectory As String)
        Dim newFolderEntry As FolderEntry           ' FolderEntry to create new Folder nodes within the currentFolderEntry
        Dim filesInCurrentDir As System.Collections.ObjectModel.ReadOnlyCollection(Of String)
        Dim i = 0                                   ' A counter for the files found in a given directory
        Dim urlFileReader As System.IO.StreamReader ' File Stream object to open an URL file
        Dim urlStreamLine As String = ""            ' String to hold a single line from an URL file

        'MsgBox("Inserting bookmarks from " & currentDirectory)
        ' Verify the given directory exists
        If (My.Computer.FileSystem.DirectoryExists(currentDirectory)) Then
            ' Retrieve list of files within current directory
            filesInCurrentDir = My.Computer.FileSystem.GetFiles(currentDirectory)
            ' If there are files within the current directory, loop through them
            If (filesInCurrentDir.Count > 0) Then
                For i = 0 To filesInCurrentDir.Count - 1
                    If (UCase(getFileNameExt(filesInCurrentDir.Item(i))) = "URL") Then
                        ' Each time a file that is a URL is encountered, read it
                        urlFileReader = My.Computer.FileSystem.OpenTextFileReader(filesInCurrentDir.Item(i))
                        ' Process through each line to find the link
                        Do While Not urlFileReader.EndOfStream
                            urlStreamLine = urlFileReader.ReadLine()
                            If (urlStreamLine.Length > 4) Then
                                ' We are looking for the substring "URL=", this must not have any other characters (including spaces) in front of it
                                If (urlStreamLine.Substring(0, 4) = "URL=") Then
                                    ' When we find the link, we set urlStreamLine equal to just the link portion, then exit our loop
                                    urlStreamLine = urlStreamLine.Substring(4, urlStreamLine.Length - 4)
                                    Exit Do ' Yes I know this is bad
                                End If
                            End If
                        Loop
                        ' Finally, we add the link/bookmark information to our current directory node
                        currentFolderEntry.addBookmarkEntry(createBookmarkEntry(getFileName(filesInCurrentDir.Item(i)), "", urlStreamLine))
                    End If
                Next i
            End If
        Else
            MsgBox("Favorites directory (" & currentDirectory & ") not found!")
        End If

        ' Retrieve first directory entry within the current directory entry
        Dim currentDirectoryInsideCurrentDirectory = Dir(currentDirectory, vbDirectory)
        Dim directoryCount As Integer       ' Counter to keep up with all of the files in the current directory, used below
        directoryCount = 0
        ' While there are directories within the current directory...
        Do While (currentDirectoryInsideCurrentDirectory <> "")
            'MsgBox("the currentDirectoryInsideCurrentDirectory is " & currentDirectoryInsideCurrentDirectory)
            ' If the given item is indeed a directory...
            If (GetAttr(currentDirectory & currentDirectoryInsideCurrentDirectory) And vbDirectory) = vbDirectory Then
                ' Create a new folder entry for the directory
                newFolderEntry = createFolderEntry(currentDirectoryInsideCurrentDirectory)
                ' Add the node to our current one
                currentFolderEntry.addFolderEntry(newFolderEntry)
                'MsgBox("sending parse " & currentDirectory & currentDirectoryInsideCurrentDirectory)
                ' Recursively call this function to add the bookmarks and folders from this new folder entry
                parseFolder(newFolderEntry, currentDirectory & currentDirectoryInsideCurrentDirectory & "\")
                ' Now we must reset our directory browser because it is stateful and if there has been parsing, then
                ' it will not currently point to the directory we need
                currentDirectoryInsideCurrentDirectory = Dir(currentDirectory, vbDirectory)
                For i = 0 To directoryCount
                    currentDirectoryInsideCurrentDirectory = Dir()
                Next i
            Else
                ' Could check files here, but in order to populate the root bookmarks, it is done above
            End If
            directoryCount = directoryCount + 1             ' Increment our directory/item count
            'MsgBox("DirectoryCount=" & directoryCount.ToString() & "; curdir=" & currentDirectoryInsideCurrentDirectory)
            If (currentDirectoryInsideCurrentDirectory <> "") Then
                currentDirectoryInsideCurrentDirectory = Dir()  ' Get next directory or item
            End If
        Loop
    End Sub

    Public Overrides Sub import(ByRef bookmanRoot As FolderEntry)
        ' Retrieve the path of the current user's favorites folder
        Dim ieFavoritesPath As String
        ieFavoritesPath = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders", "Favorites", Nothing) & "\"
        Dim folderName As String = "Internet Explorer Favorites"
        'favoritesPath = ieFavoritesPath
        'MsgBox("Importing Favorites from " & ieFavoritesPath)

        ' Create a new instance of FolderEntry to store IE's favorites data in
        Dim ieFolder As New FolderEntry
        ieFolder.Name = folderName
        ieFolder.Description = "Microsoft Internet Explorer Favorites Imports"

        ' Start parsing through the favorites directory structure
        parseFolder(ieFolder, ieFavoritesPath)

        ' Add this folder tree structure to the BookmarkManager
        If (bookmanRoot.SubFolders.IndexOf(ieFolder) < 0) Then
            bookmanRoot.addFolderEntry(ieFolder)
        Else
            MsgBox("Folder already exists")
        End If
        'Dim ieFolderIndex = refBookmarkManagerRootFolder.SubFolders.IndexOf(ieFolder)
    End Sub


    Private Sub parseFolderNodesToFavorites(ByRef currentFolderEntry As FolderEntry, ByVal currentDirectory As String)
        Dim subFolder As FolderEntry    ' Variable used to loop through subfolders
        Dim subNode As BookmarkEntry    ' Variable to loop through bookmark entries
        Dim urlPath As String           ' Name of url file
        Dim urlName As String           ' Path of url file, including name
        Dim newDirectory As String      ' SubFolder path
        Dim newLine As String = Chr(13).ToString() & Chr(10).ToString() ' Cariage return and new-line

        'MsgBox(currentDirectory & " exists, going for it...")
        ' Check to make sure folder exists...
        If (My.Computer.FileSystem.DirectoryExists(currentDirectory)) Then
            ' For every bookmark in the current folder...
            For Each subNode In currentFolderEntry.BookmarkEntries
                ' Attempt to create an .url file in the Internet Explorer Favorites folder
                Try
                    urlName = subNode.Name & ".url"
                    urlPath = System.IO.Path.Combine(currentDirectory, urlName)
                    If (Not My.Computer.FileSystem.FileExists(urlPath)) Then
                        ' This leaves some garbage at the beginning of the .url file for some reason, but seems to work
                        My.Computer.FileSystem.WriteAllText(urlPath, "[DEFAULT]" & newLine, False)
                        My.Computer.FileSystem.WriteAllText(urlPath, "BASEURL=" & subNode.URL & newLine, True)
                        My.Computer.FileSystem.WriteAllText(urlPath, "[InternetShortcut]" & newLine, True)
                        My.Computer.FileSystem.WriteAllText(urlPath, "URL=" & subNode.URL & newLine, True)
                    End If
                Catch fileException As Exception
                    'Throw fileException
                    ' Will add specific exception handling later
                    MsgBox(subNode.Name & " is an invalid filename.  I will deal with this event later!")
                End Try
            Next
            ' For each subfolder in the current directory...
            For Each subFolder In currentFolderEntry.SubFolders                     ' loop through all the subfolders
                newDirectory = currentDirectory & "\" & subFolder.Name
                ' Check to make sure the folder does not already exist within the favorites folder
                If (Not My.Computer.FileSystem.DirectoryExists(newDirectory)) Then
                    My.Computer.FileSystem.CreateDirectory(newDirectory)
                    'Else
                    '    MsgBox(newDirectory & " already exists, moving on...")
                End If
                ' Recursively parse this new folder
                parseFolderNodesToFavorites(subFolder, newDirectory)
            Next
        End If
    End Sub

    Public Overrides Sub export(ByRef bookmanRoot As FolderEntry)
        ' Retrieve the path of the current user's favorites folder
        Dim ieFavoritesPath As String
        ieFavoritesPath = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders", "Favorites", Nothing)
        'favoritesPath = ieFavoritesPath
        ' Start parsing through the bookmarks, beginning with root, to write the directories & .url(s) to the favorites folder
        parseFolderNodesToFavorites(bookmanRoot, ieFavoritesPath)
    End Sub

End Class
