Public Class frmFolderEditor

    Private m_folder As FolderEntry

    Public Sub Init(ByVal bm As BookmarkManager, ByVal folder As FolderEntry, ByVal defaultParent As FolderEntry)
        tvHierarchy.Nodes.Clear()

        FolderEntry.displayHierarchy(tvHierarchy.Nodes, bm.RootFolder, defaultParent)

        txtName.Text = folder.Name

        m_folder = folder
    End Sub

    Private Sub cmdOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOK.Click
        Try
            If txtName.Text = "" Then
                Throw New Exception("You must enter a valid folder name")
            End If

            If txtName.Text.ToLower <> m_folder.Name.ToLower Then
                Dim folder As FolderEntry
                For Each folder In CType(tvHierarchy.SelectedNode.Tag, FolderEntry).SubFolders
                    If folder.Name.ToLower = txtName.Text.ToLower Then
                        Throw New Exception("A folder by this name already exists in the selected folder." & vbCrLf & _
                                 "Change the name or the selected folder.")
                    End If
                Next
            End If
        Catch ex As Exception
            txtName.Focus()
            ttInvalid.Show(ex.Message, txtName, 5000)
            Exit Sub
        End Try

        m_folder.Name = txtName.Text

        If Not Object.ReferenceEquals(CType(tvHierarchy.SelectedNode.Tag, FolderEntry), m_folder.Parent) Then
            If Not m_folder.Parent Is Nothing Then
                m_folder.Parent.deleteFolderEntry(m_folder)
            End If
            CType(tvHierarchy.SelectedNode.Tag, FolderEntry).addFolderEntry(m_folder)
        End If

        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub BookmarkEditor_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.tvHierarchy.ImageList = frmMain.tvHierarchy.ImageList
    End Sub

End Class